/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

public class CGFBoardMouseListener implements MouseListener,
		MouseMotionListener {

	private CGFMain main;

	public CGFBoardMouseListener(CGFMain main) {
		setMain(main);
	}

	public CGFMain getMain() {
		return main;
	}

	public void setMain(CGFMain main) {
		this.main = main;
	}

	public void mouseClicked(MouseEvent e) {
		if (e.getButton() == MouseEvent.BUTTON1) {
			getMain().getGameData().getCurrentMode().click(e.getPoint());
		} else {
			getMain().getGameData().getCurrentMode().rightClick(e.getPoint());
		}
	}

	public void mouseEntered(MouseEvent e) {
	}

	public void mouseExited(MouseEvent e) {
	}

	public void mousePressed(MouseEvent e) {
	}

	public void mouseReleased(MouseEvent e) {
		if (e == null) {
			return;
		}
		getMain().getGameData().getCurrentMode().releaseMouse(e.getPoint());
	}

	public void mouseDragged(MouseEvent e) {
		getMain().getGameData().getCurrentMode().draggMouse(e.getPoint());
	}

	public void mouseMoved(MouseEvent e) {
		if (getMain().getGameData().getCurrentMode() == null) {
			return;
		}
		getMain().getGameData().getCurrentMode().moveMouse(e.getPoint());
	}

}
