/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf;

import java.awt.image.BufferedImage;

import org.w3c.dom.Node;

public class CGFBorderTerrain {
	private CGFMain main;
	private String btype;
	private String name;
	private BufferedImage imageH;
	private BufferedImage imageV;

	public CGFBorderTerrain(CGFMain main, String btype, String name,
			String vimagePath, String himagePath) {
		init(main, btype, name, vimagePath, himagePath);
	}

	public CGFBorderTerrain(CGFMain main, Node node) {
		String l_btype = CGFXMLUtil.getAttributeByName(node, "code");
		String l_name = CGFXMLUtil.getAttributeByName(node, "name");
		String vimagePath = CGFXMLUtil.getAttributeByName(node, "vimage");
		String himagePath = CGFXMLUtil.getAttributeByName(node, "himage");
		init(main, l_btype, l_name, vimagePath, himagePath);
	}

	public void init(CGFMain main, String btype, String name,
			String vimagePath, String himagePath) {
		setMain(main);
		setBtype(btype);
		setName(name);
		setImageV(CGFUtil.getImage("resource/" + vimagePath + ".png"));
		setImageH(CGFUtil.getImage("resource/" + himagePath + ".png"));
	}

	public CGFMain getMain() {
		return main;
	}

	public void setMain(CGFMain main) {
		this.main = main;
	}

	public String getBtype() {
		return btype;
	}

	public void setBtype(String btype) {
		this.btype = btype;
	}

	public BufferedImage getImageH() {
		return imageH;
	}

	public void setImageH(BufferedImage imageH) {
		this.imageH = imageH;
	}

	public BufferedImage getImageV() {
		return imageV;
	}

	public void setImageV(BufferedImage imageV) {
		this.imageV = imageV;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}
}
