/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf;

import org.w3c.dom.Node;

public class CGFCell {
	private CGFMain main;
	private CGFLocation location;
	private CGFTerrain terrain;
	private CGFCellSide sideH = null;
	private CGFCellSide sideV = null;
	
	public CGFCell(CGFMain main, CGFLocation loc, CGFTerrain terrain) {
		init(main, new CGFLocation(loc), terrain);
	}

	public CGFCell(CGFMain main, Node node) {
		String locString = CGFXMLUtil.getAttributeByName(node, "id");
		String ttype = CGFXMLUtil.getAttributeByName(node, "ttype");
		CGFLocation loc = new CGFLocation(locString);
		init(main, loc, (CGFTerrain) main.getGameData().getTerrainMap().get(ttype));
	}
	
	public void init(CGFMain main, CGFLocation loc, CGFTerrain terrain) {
		setMain(main);
		setLocation(loc);
		setTerrain(terrain);
	}

	public CGFLocation getLocation() {
		return location;
	}

	public void setLocation(CGFLocation location) {
		this.location = location;
	}

	public CGFTerrain getTerrain() {
		return terrain;
	}
	public void setTerrain(CGFTerrain terrain) {
		this.terrain = terrain;
	}
	
	public CGFCellSide getSideH() {
		return sideH;
	}

	public void setSideH(CGFCellSide sideH) {
		this.sideH = sideH;
	}

	public CGFCellSide getSideV() {
		return sideV;
	}

	public void setSideV(CGFCellSide sideV) {
		this.sideV = sideV;
	}

	public CGFMain getMain() {
		return main;
	}

	public void setMain(CGFMain main) {
		this.main = main;
	}

}
