/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf;

import org.w3c.dom.Node;

public class CGFCellSide {
	private CGFMain main;
	private String direction = "H";
	private CGFLocation location;
	private CGFBorderTerrain borderTerrain;

	public CGFCellSide(CGFMain p_main, String p_direction, CGFLocation loc,
			CGFBorderTerrain p_terrain) {
		init(p_main, p_direction, loc, p_terrain);
	}

	public CGFCellSide(CGFMain p_main, Node node) {
		setMain(p_main);
		String locString = CGFXMLUtil.getAttributeByName(node, "loc");
		CGFLocation loc = new CGFLocation(locString);
		String btype = CGFXMLUtil.getAttributeByName(node, "btype");
		String dirString = CGFXMLUtil.getAttributeByName(node, "direction");
		CGFBorderTerrain bTerrain = (CGFBorderTerrain) getMain().getGameData()
				.getBorderTerrainMap().get(btype);
		init(p_main, dirString, loc, bTerrain);
	}

	public void init(CGFMain p_main, String p_direction, CGFLocation loc,
			CGFBorderTerrain p_terrain) {
		setMain(p_main);
		setDirection(p_direction);
		setLocation(loc);
		setBorderTerrain(p_terrain);
	}

	public CGFMain getMain() {
		return main;
	}

	public void setMain(CGFMain main) {
		this.main = main;
	}

	public String getDirection() {
		return direction;
	}

	public void setDirection(String direction) {
		this.direction = direction;
	}

	public CGFLocation getLocation() {
		return location;
	}

	public void setLocation(CGFLocation location) {
		this.location = location;
	}

	public CGFBorderTerrain getBorderTerrain() {
		return borderTerrain;
	}

	public void setBorderTerrain(CGFBorderTerrain terrain) {
		this.borderTerrain = terrain;
	}
}
