/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.util.Map;

import org.w3c.dom.Node;

public class CGFDialog extends CGFUIImage {
	private String title;
	private Color titleBgColor;

	public CGFDialog(Node node, Map handlerMap, CGFFontManager fontManager) {
		super(node, handlerMap, fontManager);
	}

	public void init(Node node) {
		super.init(node);
		setTitle(CGFXMLUtil.getAttributeByName(node, "title"));
		String titleBgColorString = CGFXMLUtil.getAttributeByName(node,
				"titlebgcolor");
		setTitleBgColor(CGFUtil.stringToColor(titleBgColorString));
	}

	public void createImage() {
		super.createImage();
		Graphics2D gc = getImage().createGraphics();
		gc.setColor(getTitleBgColor());
		gc.fillRect(0, 0, getSize().width, 20);
		gc.setFont(CGFUtil.changeFontStyleSize(
				getFontManager().getNormalFont(), getFontManager()
						.getNormalFont().getStyle(), 10));
		gc.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
				RenderingHints.VALUE_ANTIALIAS_ON);
		gc.setColor(getFgColor());
		if (getTitle() != null) {
			gc.drawString(getTitle(), 10, 16);
		}
	}

	public void repaint() {
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public Color getTitleBgColor() {
		return titleBgColor;
	}

	public void setTitleBgColor(Color titleBgColor) {
		this.titleBgColor = titleBgColor;
	}

}
