/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf;

import java.util.Map;

import sjima.cgf.layer.CGFDialogLayer;

public abstract class CGFDialogAction {
	private boolean closeEnable = false;

	private CGFMain main;

	public CGFDialogAction() {
		super();
	}

	abstract public void setup();

	abstract public void commit();

	abstract public String getDialogName();

	abstract public Map createHandlerMap();

	public CGFMain getMain() {
		return main;
	}

	public void setMain(CGFMain main) {
		this.main = main;
	}

	public CGFDialog getDialog() {
		return ((CGFDialogLayer) getMain().getGameData().getLayer(
				CGFDialogLayer.LAYER_NAME)).getCurrentDispDialog();
	}

	public CGFMenuSet getMenu() {
		return ((CGFDialogLayer) getMain().getGameData().getLayer(
				CGFDialogLayer.LAYER_NAME)).getCurrentDispMenu();
	}

	public CGFDialogMode getDialogMode() {
		return (CGFDialogMode) getMain().getGameData().getModeList().get(
				CGFDialogMode.MODE_NAME);
	}


	public void setCloseEnable(boolean closeEnable) {
		this.closeEnable = closeEnable;
	}

	public boolean isCloseEnable() {
		return closeEnable;
	}

	public synchronized void closeDialog() {
		getMain().getGameData().closeDialog();
	}
	
	public CGFUIHandler createDialogHandler() {
		return new DialogHandler();
	}

	public class DialogHandler implements CGFUIHandler {
		public String getName() {
			return getDialogName();
		}

		public void onClick() {
			// 何もしない
		}

		public void onMove() {
			// 何もしない
		}

		public void onRightClick() {
			if (isCloseEnable()) {
				closeDialog();
			}
		}

	}
}
