/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

public class CGFDialogDocument {

	private CGFMain main;
	private Document document;
	private Map dialogMap;

	public CGFDialogDocument(CGFMain main, Document document, Map handlerMap) {
		setMain(main);
		setDocument(document);
		createDialogMap(handlerMap);
	}
	
	public void createDialogMap(Map handlerMap) {
		Map map = new HashMap();
		String xpath = "/dialoglist/dialog";
		List list = CGFXMLUtil.readListByXPath(getDocument(), xpath);
		for (Iterator ite = list.iterator(); ite.hasNext(); ) {
			Node node = (Node)ite.next();
			CGFDialog dialog = new CGFDialog(node, handlerMap, getMain().getFontManager());
			map.put(dialog.getName(), dialog);
		}
		
		setDialogMap(map);
	}
	
	public CGFDialog getDialog(String name) {
		return (CGFDialog) getDialogMap().get(name);
	}

	public CGFMain getMain() {
		return main;
	}

	public void setMain(CGFMain main) {
		this.main = main;
	}

	public Document getDocument() {
		return document;
	}

	public void setDocument(Document document) {
		this.document = document;
	}

	public Map getDialogMap() {
		return dialogMap;
	}

	public void setDialogMap(Map dialogMap) {
		this.dialogMap = dialogMap;
	}
	
}
