/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf;

import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.swing.filechooser.FileFilter;

public class CGFFileFilter extends FileFilter implements java.io.FileFilter {
	private List list = new ArrayList();
	private List exList = new ArrayList();
	private String description;
	private boolean isDirectoryOnly = false;
	
	public void add(String filter) {
		getList().add(filter);
	}
	
	public void addExList(String fileName) {
		getExList().add(fileName);
	}
	
	public boolean accept(File f) {
		if (f.getName().charAt(0) == '.') {
			return false;
		}
		
		if (getExList().contains(f.getName())) {
			return false;
		}
		
		if (f.isDirectory()) {
			return true;
		}
		if (isDirectoryOnly()) {
			return false;
		}
		for (Iterator ite = list.iterator(); ite.hasNext(); ) {
			String pattern = (String)ite.next();
			pattern = ".+[.]" + pattern + "$";
			if (f.getPath().matches(pattern)) {
				return true;
			}
		}
		return false;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public List getList() {
		return list;
	}

	public List getExList() {
		return exList;
	}

	public void setDirectoryOnly(boolean isDirectoryOnly) {
		this.isDirectoryOnly = isDirectoryOnly;
	}

	public boolean isDirectoryOnly() {
		return isDirectoryOnly;
	}
	
}
