package sjima.cgf;

import java.awt.Font;
import java.awt.GraphicsEnvironment;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

public class CGFFontManager {
	private CGFMain main;
	private Document document = null;
	private Font normalFont = new Font("SansSerif", Font.PLAIN, 10);
	private Font monoFont = new Font("Monospaced", Font.PLAIN, 10);

	public CGFFontManager(CGFMain main) {
		setMain(main);
		boolean isFontDebug = false;
		if (getMain().getSetting() != null) {
			String strFontDebug = getMain().getSetting().getStringValue(
					"fontdebug");
			isFontDebug = "true".equals(strFontDebug);
		}

		GraphicsEnvironment ge = GraphicsEnvironment
				.getLocalGraphicsEnvironment();
		Font[] fonts = ge.getAllFonts();
		Set allFontSet = new HashSet();
		for (int i = 0; i < fonts.length; i++) {
			allFontSet.add(fonts[i].getName());
			if (isFontDebug) {
				System.out.println(fonts[i].getName());
			}
		}
		try {
			setDocument(CGFXMLUtil.loadXML("resource/font.xml"));
		} catch (Exception e) {
		}
		if (getDocument() == null) {
			return;
		}
		String xpath = "fontlist/font";
		List nodeList = CGFXMLUtil.readListByXPath(getDocument(), xpath);
		boolean monoSeted = false;
		boolean normalSeted = false;
		for (Iterator ite = nodeList.iterator(); ite.hasNext();) {
			Node node = (Node) ite.next();
			String type = CGFXMLUtil.getAttributeByName(node, "type");
			String name = CGFXMLUtil.getAttributeByName(node, "name");
			String style = CGFXMLUtil.getAttributeByName(node, "style");
			int fontStyle = Font.PLAIN;
			if ("bold".equals(style)) {
				fontStyle = Font.BOLD;
			}
			if (allFontSet.contains(name)) {
				if ("monospaced".equals(type) && (!monoSeted)) {
					Font font = new Font(name, fontStyle, 10);
					if (font != null) {
						setMonoFont(font);
						monoSeted = true;
						if (isFontDebug) {
							System.out.println("monospaced = " + name);
						}
					}
				} else if ("normal".equals(type) && (!normalSeted)) {
					Font font = new Font(name, fontStyle, 10);
					if (font != null) {
						normalSeted = true;
						setNormalFont(font);
						if (isFontDebug) {
							System.out.println("normal = " + name);
						}
					}
				}
			}
		}
	}

	public static void main(String[] args) {
		GraphicsEnvironment ge = GraphicsEnvironment
				.getLocalGraphicsEnvironment();
		Font[] fonts = ge.getAllFonts();
		Set allFontSet = new HashSet();
		for (int i = 0; i < fonts.length; i++) {
			allFontSet.add(fonts[i].getName());
			System.out.println(fonts[i].getName());
		}
	}

	public void setMain(CGFMain main2) {
		this.main = main2;
	}

	public CGFMain getMain() {
		return this.main;
	}

	public void setDocument(Document document) {
		this.document = document;
	}

	public Document getDocument() {
		return document;
	}

	public void setNormalFont(Font normalFont) {
		this.normalFont = normalFont;
	}

	public Font getNormalFont() {
		return normalFont;
	}

	public void setMonoFont(Font monoFont) {
		this.monoFont = monoFont;
	}

	public Font getMonoFont() {
		return monoFont;
	}

}
