/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf;


public abstract class CGFGamePhase implements Runnable {
	private CGFPhaseManager phaseManager;
	private boolean restart = false;
	public abstract String getPhaseName();
	public void execute() {
		setRestart(false);
		Thread thread = new Thread(this);
		thread.start();
	}
	public void restart() {
		setRestart(true);
		Thread thread = new Thread(this);
		thread.start();
	}
	public abstract void run();
	public void finish() {
		getPhaseManager().finishPhase();
	}
	public void returnPrevPhase() {
		getPhaseManager().returnPrevPhase();
	}
	public void setPhaseManager(CGFPhaseManager manager) {
		phaseManager = manager;
	}
	public CGFPhaseManager getPhaseManager() {
		return phaseManager;
	}
	public abstract CGFMode getDefaultMode();
	public boolean isRestart() {
		return restart;
	}
	public void setRestart(boolean restart) {
		this.restart = restart;
	}
	public void commit() {
	}
	
	public void cancel() {
	}
}
