/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf;

import java.util.ArrayList;
import java.util.List;

public class CGFGameSetup extends CGFPhaseManager {
	private CGFMain main;
	private List setupPhaseList = new ArrayList();

	public CGFGameSetup(CGFMain main) {
		setMain(main);
	}

	public CGFMain getMain() {
		return main;
	}

	public void setMain(CGFMain main) {
		this.main = main;
	}

	public List getSetupPhaseList() {
		return setupPhaseList;
	}

	public void setSetupPhaseList(List setupPhaseList) {
		this.setupPhaseList = setupPhaseList;
	}

	public void buildPhaseList() {
		List list = getSetupPhaseList();
		list.clear();
		list.add(new GameStartPhase(this));
		setPhaseList(list);
	}

	private class GameStartPhase extends CGFGamePhase {
		public GameStartPhase(CGFPhaseManager manager) {
			setPhaseManager(manager);
		}

		public String getPhaseName() {
			return "Game Start Phase";
		}

		public void run() {
		}

		public CGFMode getDefaultMode() {
			return (CGFMode) getMain().getGameData().getModeList().get(
					CGFMode.MODE_NAME);
		}

	}
}
