/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf;

public class CGFLocationIterator implements java.util.Iterator {
	private CGFLocation loc;
	private CGFSize size;
	private CGFLocation firstLoc;
	
	public CGFLocationIterator(CGFSize size, CGFLocation loc) {
		this.loc = null;
		this.firstLoc = loc;
		this.size = size;
	}
	
	public CGFLocationIterator(CGFSize size) {
		this.loc = null;
		this.firstLoc = new CGFLocation(0, 0);
		this.size = size;
	}

	public boolean hasNext() {
		if (this.loc == null) {
			return true;
		}
		if (this.loc.row < this.size.height - 1) {
			return true;
		}
		if (this.loc.row == this.size.height - 1) {
			if (this.loc.col < this.size.width - 1) {
				return true;
			}
		}
		
		return false;
	}

	public Object next() {
		if (loc == null) {
			loc = firstLoc;
			return loc;
		}
		loc.col++;
		if (loc.col >= size.width) {
			loc.col -= size.width;
			loc.row++;
		}
		if (loc.row >= size.height) {
			return null;
		}
		
		return loc;
	}

	public void remove() {
		// unsuport
	}

}
