/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf;

import java.awt.Dimension;
import java.util.Map;

import org.w3c.dom.Node;

public class CGFMenu extends CGFUIImage {
	private CGFMenuSet menuSet;
	private int no;
	private int margin = 0;

	public CGFMenu(int no, CGFMenuSet menuSet, Node node, Map handlerMap, CGFFontManager fontManager) {
		setFontManager(fontManager);
		setNo(no);
		setMenuSet(menuSet);
		setHandlerMap(handlerMap);
		init(node);
		createImage();
		drawPartsList();
	}

	public void init(Node node) {
		setShadow(true);
		setName(CGFXMLUtil.getAttributeByName(node, "name"));
		setLabel(CGFXMLUtil.getAttributeByName(node, "label"));
		setImagePath(CGFXMLUtil.getAttributeByName(node, "imagepath"));
		// サイズはMenuSetから貰う
		Dimension size = new Dimension(getMenuSet().getItemSize());
		size.width -= (getMargin() * 2);
		size.height -= (getMargin() * 2);
		setSize(size);
		getPoint().y = (getNo() * getMenuSet().getItemSize().height) + getMargin();
		getPoint().x = getMargin();
		String labelTop = CGFXMLUtil.getAttributeByName(node, "labeltop");
		if (labelTop != null) {
			getLabelPoint().y = Integer.parseInt(labelTop);
		}
		String labelLeft = CGFXMLUtil.getAttributeByName(node, "labelleft");
		if (labelLeft != null) {
			getLabelPoint().x = Integer.parseInt(labelLeft);
		}

		String bgColorString = CGFXMLUtil.getAttributeByName(node, "bgcolor");
		if (bgColorString != null) {
			setBgColor(CGFUtil.stringToColor(bgColorString));
		}
		String fgColorString = CGFXMLUtil.getAttributeByName(node, "fgcolor");
		if (fgColorString != null) {
			setFgColor(CGFUtil.stringToColor(fgColorString));
		}
		String enable = CGFXMLUtil.getAttributeByName(node, "enable");
		setEnable(!"0".equals(enable));
	}

	public CGFMenuSet getMenuSet() {
		return menuSet;
	}

	public void setMenuSet(CGFMenuSet menuSet) {
		this.menuSet = menuSet;
	}

	public int getNo() {
		return no;
	}

	public void setNo(int no) {
		this.no = no;
	}

	public int getMargin() {
		return margin;
	}

	public void setMargin(int margin) {
		this.margin = margin;
	}

}
