/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

public class CGFMenuDocument {

	private CGFMain main;
	private Document document;
	private Map menuSetMap;
	
	public CGFMenuDocument(CGFMain main, Document document, Map handlerMap) {
		setMain(main);
		setDocument(document);
		createMenuSetMap(handlerMap);
	}

	public void createMenuSetMap(Map handlerMap) {
		Map map = new HashMap();
		String xpath = "/menusetlist/menuset";
		List list = CGFXMLUtil.readListByXPath(getDocument(), xpath);
		for (Iterator ite = list.iterator(); ite.hasNext(); ) {
			Node node = (Node)ite.next();
			CGFMenuSet menuSet = new CGFMenuSet(node, handlerMap, getMain().getFontManager());
			map.put(menuSet.getName(), menuSet);
		}
		
		setMenuSetMap(map);
	}

	public CGFMain getMain() {
		return main;
	}
	public void setMain(CGFMain main) {
		this.main = main;
	}
	public Document getDocument() {
		return document;
	}
	public void setDocument(Document document) {
		this.document = document;
	}
	public Map getMenuSetMap() {
		return menuSetMap;
	}
	public void setMenuSetMap(Map menuSetMap) {
		this.menuSetMap = menuSetMap;
	}

	public CGFMenuSet getMenuSet(String dialogName) {
		return (CGFMenuSet) getMenuSetMap().get(dialogName);
	}
	
}
