/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf;

import java.awt.Dimension;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.w3c.dom.Node;

public class CGFMenuSet extends CGFUIImage {
	private Dimension itemSize;

	public CGFMenuSet(Node node, Map handlerMap, CGFFontManager fontManager) {
		super(node, handlerMap, fontManager);
	}
	
	public void init(Node node) {
		super.init(node);
		setItemSize(new Dimension());
		String itemWidthStr = CGFXMLUtil.getAttributeByName(node, "itemwidth");
		if (itemWidthStr != null) {
			getItemSize().width = Integer.parseInt(itemWidthStr);
		}
		String itemHeightStr = CGFXMLUtil.getAttributeByName(node, "itemheight");
		if (itemHeightStr != null) {
			getItemSize().height = Integer.parseInt(itemHeightStr);
		}

		Map parts = getPartsMap();
		List menuNodeList = CGFXMLUtil.readListByXPath(node, "menu");
		if (menuNodeList != null && (this instanceof CGFMenuSet) ) {
			int i = 0;
			for (Iterator ite = menuNodeList.iterator(); ite.hasNext();) {
				Node partsNode = (Node) ite.next();
				CGFUIImage part = new CGFMenu(i, this, partsNode, getHandlerMap(), getFontManager());
				parts.put(part.getName(), part);
				if (part.isEnable() ) {
					i++;
				}
			}
		}
		setPartsMap(parts);
	}

	public Dimension getItemSize() {
		return itemSize;
	}

	public void setItemSize(Dimension itemSize) {
		this.itemSize = itemSize;
	}

}
