/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf;

import java.awt.Color;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class CGFPlayer {
	public final static String AI_YES = "1";
	public final static String AI_NO = "0";
	
	private CGFMain main;
	private String no;
	private String name;
	private String ai;
	private String disable;
	private Color color;
	
	public CGFPlayer(CGFMain main, String no) {
		init(main, no);
	}
	
	public CGFPlayer(CGFMain main, Node node) {
		String no = CGFXMLUtil.getAttributeByName(node, "no");
		init(main, no);
		setName(CGFXMLUtil.getAttributeByName(node, "name"));
		setAi(CGFXMLUtil.getAttributeByName(node, "ai"));
		try {
			int ix = Integer.parseInt(no) - 1;
			if (ix < getMain().getGameData().getColorList().size()) {
				Color color = (Color) getMain().getGameData().getColorList().get(ix);
				setColor(color);
			}
		} catch (NumberFormatException e) {
		}
		setDisable("0");
	}
	
	public void init(CGFMain main, String no) {
		setMain(main);
		setNo(no);
		setName("player " + no);
		setAi(AI_YES);
		setColor(new Color(127,127,127,255));
	}
	
	public Node createNode(Document doc) {
		Element node = doc.createElement("player");
		node.setAttribute("no", getNo());
		node.setAttribute("name", getName());
		node.setAttribute("ai", getAi());
		node.setAttribute("color", CGFUtil.colorToString(getColor()));
		node.setAttribute("disable", getDisable());
		
		return node;
	}

	public CGFMain getMain() {
		return main;
	}

	public void setMain(CGFMain main) {
		this.main = main;
	}

	public String getNo() {
		return no;
	}
	public void setNo(String no) {
		this.no = no;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getAi() {
		return ai;
	}
	public void setAi(String ai) {
		this.ai = ai;
	}
	public Color getColor() {
		return color;
	}
	public void setColor(Color color) {
		this.color = color;
	}

	public String getDisable() {
		return disable;
	}

	public void setDisable(String disable) {
		this.disable = disable;
	}

}
