/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf;

/**
 * 行列形式のデータテーブルクラス
 * @author shio
 *
 */
public class CGFRowColsTable {

	private Object[][] dataTable;
	private CGFSize size;
	
	/**
	 * コンストラクタ
	 * @param p_size
	 */
	public CGFRowColsTable(CGFSize p_size, CGFRowColsTableDataBuilder builder) {
		size = p_size;
		dataTable = new Object[size.height][size.width];
		clear(builder);
	}
	
	public void clear(CGFRowColsTableDataBuilder builder)
	{
		CGFLocation loc = new CGFLocation(0, 0);
		for (loc.row = 0; loc.row < size.height; loc.row++) {
			for (loc.col = 0; loc.col < size.width; loc.col++) {
				dataTable[loc.row][loc.col] = builder.createData(loc);
			}
		}
	}
	
	public Object getData(CGFLocation loc) {
		if (loc.row < 0) {
			return null;
		}
		if (loc.col < 0) {
			return null;
		}
		if (loc.row >= dataTable.length) {
			return null;
		}
		if (loc.col >= dataTable[0].length) {
			return null;
		}
		return dataTable[loc.row][loc.col];
	}
	
	void setData(CGFLocation loc, Object data) {
		dataTable[loc.row][loc.col] = data;
	}
	
}
