/**
 * Tokyo Railways 
 * 
 * copyright 2009 Mitsunobu SHIOJIMA
 */

package sjima.cgf;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

public class CGFSetting {
	private Document document = null;
	private Map valueMap = new HashMap();
	
	public CGFSetting() {
		try {
			setDocument(CGFXMLUtil.loadXML("resource/setting.xml"));
		} catch (Exception e) {
		}
		if (getDocument() == null) {
			return;
		}
		
		List nodeList = CGFXMLUtil.readListByXPath(getDocument(), "/settinglist/setting");
		for (Iterator ite = nodeList.iterator(); ite.hasNext();) {
			Node node = (Node)ite.next();
			String name = CGFXMLUtil.getAttributeByName(node, "name");
			String value = CGFXMLUtil.getAttributeByName(node, "value");
			getValueMap().put(name, value);
		}
	}

	public void setDocument(Document document) {
		this.document = document;
	}

	public Document getDocument() {
		return document;
	}

	public Map getValueMap() {
		return valueMap;
	}
	
	public String getStringValue(String name) {
		return (String)getValueMap().get(name);
	}
	
	public int getIntegerValue(String name) {
		int result = 0;
		try {
			String value = getStringValue(name);
			if (value != null) {
				result = Integer.parseInt(value);
			}
		} catch (NumberFormatException e) {
		}
		return result;
	}

}
