/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf;

import java.awt.image.BufferedImage;

import org.w3c.dom.Node;

public class CGFTerrain {

	private String terrain;
	private BufferedImage image;
	private CGFMain main;
	private String name;
	private String imagePath;

	public CGFTerrain(CGFMain p_main, String p_terrain, BufferedImage p_image, String imagePath, String p_name) {
		setMain(p_main);
		setTerrain(p_terrain);
		setImagePath(imagePath);
		setImage(p_image);
		setName(p_name);
	}
	
	public CGFTerrain(CGFMain p_main, String p_terrain, String imagePath, String name) {
		setMain(p_main);
		setTerrain(p_terrain);
		setImage(CGFUtil.getImage(imagePath));
		setImagePath(imagePath);
		setName(name);
	}
	
	public static CGFTerrain create(CGFMain main, Node node) {
		String terrain = CGFXMLUtil.getAttributeByName(node, "code");
		String imagePath = "resource/" + CGFXMLUtil.getAttributeByName(node, "image") + ".png";
		String name = CGFXMLUtil.getAttributeByName(node, "name");
		
		return new CGFTerrain(main, terrain, imagePath, name);
	}

	public String getTerrain() {
		return terrain;
	}

	public void setTerrain(String terrain) {
		this.terrain = terrain;
	}

	public BufferedImage getImage() {
		return image;
	}

	public void setImage(BufferedImage image) {
		this.image = image;
	}
	public CGFMain getMain() {
		return main;
	}

	public void setMain(CGFMain main) {
		this.main = main;
	}
	
	public String toString() {
		return getName();
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public void setImagePath(String imagePath) {
		this.imagePath = imagePath;
	}

	public String getImagePath() {
		return imagePath;
	}

}
