/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf.layer;

import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.image.BufferedImage;

import sjima.cgf.CGFCell;
import sjima.cgf.CGFCellSide;
import sjima.cgf.CGFFullSizeLayer;
import sjima.cgf.CGFLocation;
import sjima.cgf.CGFMain;
import sjima.cgf.CGFSize;

public class CGFBorderTerrainLayer extends CGFFullSizeLayer {

	public CGFBorderTerrainLayer(CGFMain main, CGFSize size) {
		super(main, size);
	}

	public String getLayerName() {
		return "BorderTerrainLayer";
	}

	public void updateAtLocation(CGFLocation loc) {
		Graphics2D gc = getLayerImage().createGraphics();
		CGFCell cell = (CGFCell) getMain().getGameData().getCellTable()
				.getData(loc);
		CGFCellSide cellSideH = cell.getSideH();
		if (cellSideH != null && cellSideH.getBorderTerrain() != null) {
			BufferedImage img = cellSideH.getBorderTerrain().getImageH();
			Point p = getMain().getGameData().getLocationPoint(loc);
			CGFSize cellSize = getMain().getGameData().getSquareSize();
			p.y -= img.getHeight() / 2;
			p.x += (cellSize.width - img.getWidth()) / 2;
			gc.drawImage(img, p.x, p.y, null);
		}
		CGFCellSide cellSideV = cell.getSideV();
		if (cellSideV != null && cellSideV.getBorderTerrain() != null) {
			BufferedImage img = cellSideV.getBorderTerrain().getImageV();
			Point p = getMain().getGameData().getLocationPoint(loc);
			CGFSize cellSize = getMain().getGameData().getSquareSize();
			p.x -= img.getWidth() / 2;
			p.y += (cellSize.height - img.getHeight()) / 2;
			gc.drawImage(img, p.x, p.y, null);
		}
	}
}
