/*
 * Common Game Fundation
 *
 * Copyright 2008 M.SHIOJIMA
 */

package sjima.cgf.layer;

import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.image.BufferedImage;

import sjima.cgf.CGFCell;
import sjima.cgf.CGFFullSizeLayer;
import sjima.cgf.CGFLocation;
import sjima.cgf.CGFMain;
import sjima.cgf.CGFSize;
import sjima.cgf.CGFTerrain;

public class CGFTerrainLayer extends CGFFullSizeLayer {

	public static final String LAYER_NAME = "terrainLayer";

	public CGFTerrainLayer(CGFMain main, CGFSize size) {
		super(main, size);
	}

	public String getLayerName() {
		return LAYER_NAME;
	}

	public void updateAtLocation(CGFLocation loc) {
		Graphics2D gc = getLayerImage().createGraphics();
		CGFCell cell = (CGFCell) getMain().getGameData().getCellTable()
				.getData(loc);
		CGFTerrain terrain = cell.getTerrain();
		if (terrain == null) {
			System.out.println("unkown terrain [" + cell.getLocation() + "]");
			return;
		}
		BufferedImage img = terrain.getImage();
		Point p = getMain().getGameData().getLocationPoint(loc);
		gc.drawImage(img, p.x, p.y, null);

	}

}
