package sjima.wop;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import sjima.cgf.CGFCell;
import sjima.cgf.CGFFactory;
import sjima.cgf.CGFLocation;
import sjima.cgf.CGFMain;
import sjima.cgf.CGFPlayer;
import sjima.cgf.CGFTerrain;

public class WOPFactory extends CGFFactory {

	public WOPFactory(CGFMain main) {
		super(main);
		setCellBuilder(new CellBuilder());
	}

	public WOPGameData createGameData() {
		return new WOPGameData(getMain());
	}

	public WOPMainFrame createMainFrame() {
		return new WOPMainFrame(getMain(), "Wars of Powers");
	}

	public WOPTerrain createTerrain(Node node) {
		return WOPTerrain.create(getMain(), node);
	}

	public CGFPlayer createPlayer(Node node) {
		return new WOPPlayer(getMain(), node);
	}

	public CGFCell createCell(CGFLocation loc, CGFTerrain terrain) {
		return new WOPCell(getMain(), loc, terrain);
	}
	
	public CGFCell createCell(Node node) {
		return new WOPCell(getMain(), node);
	}

	public WOPMapDocument createMapDocument(Document doc) {
		return new WOPMapDocument(getMain(), doc);
	}
	
	public WOPMain getMain() {
		return (WOPMain)super.getMain();
	}

	public class CellBuilder extends CGFFactory.CellBuilder {
		protected CellBuilder() {
			super();
		}

		public Object createData(CGFLocation loc) {
			return createCell(loc, getMain().getGameData().getDefaultTerrain());
		}

		public Object createFromNode(Node node) {
			return createCell(node);
		}
	}
}
