package sjima.wop;

import java.util.Iterator;

import sjima.cgf.CGFSoundSetting;

public class WOPSoundSetting extends CGFSoundSetting {

	public String getStageSound(String no) {
		String result = getStageSoundFile(no);
		if (result == null) {
			return result;
		}
		return getSoundFileDirectory() + "/" + result;
	}

	public String getStageSoundFile(String no) {
		String defaultStageSound = null;

		for (Iterator ite = getSoundList().values().iterator(); ite.hasNext();) {
			SoundSetting sound = (SoundSetting) ite.next();
			if ("stage".equals(sound.getType())) {
				String stageNo = (String) sound.getAttrMap().get("no");
				if (stageNo == null) {
					defaultStageSound = sound.getSoundFile();
				} else if (stageNo.equals(no)) {
					return sound.getSoundFile();
				}
			}
		}
		return defaultStageSound;
	}

	public String getVictorySound() {
		String result = getVictorySoundFile();
		if (result == null) {
			return result;
		}
		return getSoundFileDirectory() + "/" + result;
	}

	private String getVictorySoundFile() {
		String result = null;

		for (Iterator ite = getSoundList().values().iterator(); ite.hasNext();) {
			SoundSetting sound = (SoundSetting) ite.next();
			if ("victory".equals(sound.getType())) {
				result = sound.getSoundFile();
				break;
			}
		}

		return result;
	}
}
