/**
 * Wars of Powers 
 * 
 * copyright 2009 Mitsunobu SHIOJIMA
 */
package sjima.wop;

import java.awt.image.BufferedImage;

import org.w3c.dom.Node;

import sjima.cgf.CGFTerrain;
import sjima.cgf.CGFXMLUtil;

public class WOPTerrain extends CGFTerrain {
	private int fertility;
	private int attack;
	private int defence;
	private int capacity;
	private int garrison;
	private int maxGrowth;
	private int moveStart;
	private int defenceMorale;
	private int attackMorale;

	public WOPTerrain(WOPMain p_main, String p_terrain, String p_imagePath, BufferedImage p_image,
			String p_name, int ferility, int attack, int defence, int capacity,
			int garrison, int maxGrouwth, int moveStart, int defenceMorale,
			int attackMorale) {
		super(p_main, p_terrain, p_image, p_imagePath, p_name);
		setFertility(ferility);
		setAttack(attack);
		setDefence(defence);
		setCapacity(capacity);
		setGarrison(garrison);
		setMaxGrowth(maxGrouwth);
		setMoveStart(moveStart);
		setDefenceMorale(defenceMorale);
		setAttackMorale(attackMorale);
	}

	public WOPTerrain(WOPMain p_main, String p_terrain, String imagePath,
			String p_name, int ferility, int attack, int defence, int capacity,
			int garrison, int maxGrouwth, int moveStart, int defenceMorale,
			int attackMorale) {
		super(p_main, p_terrain, imagePath, p_name);
		setFertility(ferility);
		setAttack(attack);
		setDefence(defence);
		setCapacity(capacity);
		setGarrison(garrison);
		setMaxGrowth(maxGrouwth);
		setMoveStart(moveStart);
		setDefenceMorale(defenceMorale);
		setAttackMorale(attackMorale);
	}

	public static WOPTerrain create(WOPMain main, Node node) {
		String terrain = CGFXMLUtil.getAttributeByName(node, "code");
		String imagePath = "resource/"
				+ CGFXMLUtil.getAttributeByName(node, "image") + ".png";
		String name = CGFXMLUtil.getAttributeByName(node, "name");
		int ferility = CGFXMLUtil.getAttributeIntegerByName(node, "fertility");
		int attack = CGFXMLUtil.getAttributeIntegerByName(node, "attack");
		int capacity = CGFXMLUtil.getAttributeIntegerByName(node, "capacity");
		int defence = CGFXMLUtil.getAttributeIntegerByName(node, "defence");
		int garrison = CGFXMLUtil.getAttributeIntegerByName(node, "garrison");
		int maxgrowth = CGFXMLUtil.getAttributeIntegerByName(node, "maxgrowth");
		int movestart = CGFXMLUtil.getAttributeIntegerByName(node, "movestart");
		int defenceMorale = CGFXMLUtil.getAttributeIntegerByName(node,
				"defenceMorale");
		int attackMorale = CGFXMLUtil.getAttributeIntegerByName(node,
				"attackMorale");

		WOPTerrain instance = new WOPTerrain(main, terrain, imagePath, name,
				ferility, attack, defence, capacity, garrison, maxgrowth,
				movestart, defenceMorale, attackMorale);

		return instance;
	}

	public void setDefence(int defence) {
		this.defence = defence;
	}
	
	public int getDefence() {
		return defence;
	}

	public int getDefence(WOPPlayer player) {
		return defence + player.getTerrainModify(getTerrain(), "defence");
	}

	public void setFertility(int fertility) {
		this.fertility = fertility;
	}

	public int getFertility() {
		return fertility;
	}

	public int getFertility(WOPPlayer player) {
		return fertility + player.getTerrainModify(getTerrain(), "fertility");
	}

	public void setGarrison(int garrison) {
		this.garrison = garrison;
	}

	public int getGarrison() {
		return garrison;
	}

	public int getGarrison(WOPPlayer player) {
		return garrison + player.getTerrainModify(getTerrain(), "garrison");
	}

	public void setMaxGrowth(int maxGrowth) {
		this.maxGrowth = maxGrowth;
	}

	public int getMaxGrowth() {
		return maxGrowth;
	}

	public int getMaxGrowth(WOPPlayer player) {
		return maxGrowth + player.getTerrainModify(getTerrain(), "maxgrowth");
	}

	public void setAttack(int attack) {
		this.attack = attack;
	}
	
	public int getAttack() {
		return attack;
	}

	public int getAttack(WOPPlayer player) {
		return attack + player.getTerrainModify(getTerrain(), "attack");
	}

	public void setCapacity(int capacity) {
		this.capacity = capacity;
	}
	
	public int getCapacity() {
		return capacity;
	}

	public int getCapacity(WOPPlayer player) {
		return capacity + player.getTerrainModify(getTerrain(), "capacity");
	}

	public void setMoveStart(int moveStart) {
		this.moveStart = moveStart;
	}
	
	public int getMoveStart() {
		return moveStart;
	}

	public int getMoveStart(WOPPlayer player) {
		return moveStart + player.getTerrainModify(getTerrain(), "movestart");
	}

	public void setDefenceMorale(int defenceMorale) {
		this.defenceMorale = defenceMorale;
	}
	
	public int getDefenceMorale() {
		return defenceMorale;
	}

	public int getDefenceMorale(WOPPlayer player) {
		return defenceMorale
				+ player.getTerrainModify(getTerrain(), "defenceMorale");
	}

	public void setAttackMorale(int attackMorale) {
		this.attackMorale = attackMorale;
	}
	
	public int getAttackMorale() {
		return attackMorale;
	}

	public int getAttackMorale(WOPPlayer player) {
		return attackMorale + player.getTerrainModify(getTerrain(), "attackMorale");
	}

}
