package sjima.wop.action;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import sjima.cgf.CGFDialogAction;
import sjima.cgf.CGFUIHandler;
import sjima.cgf.CGFUIImage;
import sjima.wop.WOPMain;
import sjima.wop.event.WOPEvent;
import sjima.wop.mode.WOPDialogMode;

public class WOPEventListDialogAction extends CGFDialogAction {
	public static final String DIALOG_NAME = "event";
	private String returnDialog;
	private String returnDialog2;
	public static final int MAX_LINE = 12;
	private int page = 0;

	public WOPEventListDialogAction(WOPMain main) {
		super.setMain(main);
	}

	@Override
	public void commit() {
	}

	@Override
	public Map createHandlerMap() {
		Map map = new HashMap();
		CGFUIHandler handler = new CloseHandler();
		map.put(handler.getName(), handler);
		handler = new PrevHandler();
		map.put(handler.getName(), handler);
		handler = new NextHandler();
		map.put(handler.getName(), handler);
		
		return map;
	}

	@Override
	public String getDialogName() {
		return DIALOG_NAME;
	}

	@Override
	public void setup() {
		updateDialog();
	}

	private void updateDialog() {
		List eventList = new ArrayList(getMain().getGameData()
				.getEventManager().getEventMap().values());
		if (getPage() < totalPage() - 1) {
			CGFUIImage part = (CGFUIImage)getDialog().getPartsMap().get("event.next");
			part.setEnable(true);
		} else {
			CGFUIImage part = (CGFUIImage)getDialog().getPartsMap().get("event.next");
			part.setEnable(false);
		}
		if (getPage() > 0) {
			CGFUIImage part = (CGFUIImage)getDialog().getPartsMap().get("event.prev");
			part.setEnable(true);
		} else {
			CGFUIImage part = (CGFUIImage)getDialog().getPartsMap().get("event.prev");
			part.setEnable(false);
		}
		for (int i = 0; i < MAX_LINE; i++) {
			int ix = i + page * MAX_LINE;
			if (ix < eventList.size()) {
				WOPEvent event = (WOPEvent) eventList.get(ix);

				CGFUIImage part = (CGFUIImage) getDialog().getPartsMap().get(
						"event.name" + (i + 1));
				part.setEnable(true);
				part.setLabel(event.getName());

				part = (CGFUIImage) getDialog().getPartsMap().get(
						"event.rate" + (i + 1));
				part.setEnable(true);
				part.setLabel(event.getRateString());
				part = (CGFUIImage) getDialog().getPartsMap().get(
						"event.effect" + (i + 1));
				part.setLabel(event.getDesc());
				part.setEnable(true);

			} else {
				CGFUIImage part = (CGFUIImage) getDialog().getPartsMap().get(
						"event.name" + (i + 1));
				part.setEnable(false);

				part = (CGFUIImage) getDialog().getPartsMap().get(
						"event.rate" + (i + 1));
				part.setEnable(false);
				part = (CGFUIImage) getDialog().getPartsMap().get(
						"event.effect" + (i + 1));
				part.setEnable(false);
			}
		}

		setCloseEnable(true);
	}

	public void setReturnDialog(String returnDialog) {
		this.returnDialog = returnDialog;
	}

	public String getReturnDialog() {
		return returnDialog;
	}

	public void setReturnDialog2(String returnDialog2) {
		this.returnDialog2 = returnDialog2;
	}

	public String getReturnDialog2() {
		return returnDialog2;
	}
	
	public WOPMain getMain() {
		return (WOPMain)super.getMain();
	}
	
	public void setPage(int page) {
		this.page = page;
	}

	public int getPage() {
		return page;
	}

	public int totalPage() {
		int result = getMain().getGameData().getTerrainMap().size() / MAX_LINE;
		if ((getMain().getGameData().getTerrainMap().size() % MAX_LINE) > 0) {
			result++;
		}
		return result;
	}

	public void closeDialog() {
		super.closeDialog();
		if (getReturnDialog() != null) {
			WOPDialogMode dialogMode = (WOPDialogMode) ((WOPMain) getMain())
					.getGameData().getModeList().get(WOPDialogMode.MODE_NAME);
			getMain().getGameData().setCurrentMode(dialogMode);
			dialogMode.setFinishHandler(null);
			CGFDialogAction action = dialogMode.getAction(getReturnDialog());
			if (action instanceof WOPMenu1Action) {
				WOPMenu1Action menuAction = (WOPMenu1Action) action;
				menuAction.setReturnDialog(getReturnDialog2());
			}
			dialogMode.dispDialog(action);
		}
	}

	public class CloseHandler implements CGFUIHandler {
		public static final String HANDLER_NAME = "event.close";

		public String getName() {
			return HANDLER_NAME;
		}

		public void onClick() {
			closeDialog();
		}

		public void onRightClick() {
		}

		public void onMove() {
		}
	}
	
	public class PrevHandler implements CGFUIHandler {
		public static final String HANDLER_NAME = "event.prev";

		public String getName() {
			return HANDLER_NAME;
		}

		public void onClick() {
			setPage(getPage() - 1);
			
			updateDialog();
			WOPDialogMode mode = (WOPDialogMode) getMain().getGameData()
					.getCurrentMode();
			mode.repaintDialog();
		}

		public void onRightClick() {
		}

		public void onMove() {
		}
	}
	
	public class NextHandler implements CGFUIHandler {
		public static final String HANDLER_NAME = "event.next";

		public String getName() {
			return HANDLER_NAME;
		}

		public void onClick() {
			setPage(getPage() + 1);

			updateDialog();
			WOPDialogMode mode = (WOPDialogMode) getMain().getGameData()
					.getCurrentMode();
			mode.repaintDialog();
		}

		public void onRightClick() {
		}

		public void onMove() {
		}
	}
}
