/**
 * Tokyo Railways 
 * 
 * copyright 2008 Mitsunobu SHIOJIMA
 */
package sjima.wop.action;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.JOptionPane;

import sjima.cgf.CGFDialogAction;
import sjima.cgf.CGFUIHandler;
import sjima.cgf.CGFUIImage;
import sjima.wop.WOPMain;
import sjima.wop.WOPPlayer;

public class WOPPrizeDialogAction extends CGFDialogAction {
	public static final String DIALOG_NAME = "prize";

	public WOPPrizeDialogAction(WOPMain main) {
		setMain(main);
	}

	public void commit() {
	}

	public Map createHandlerMap() {
		Map map = new HashMap();
		CGFUIHandler handler = new CloseHandler();
		map.put(handler.getName(), handler);
		return map;
	}

	public String getDialogName() {
		return DIALOG_NAME;
	}

	public void setup() {
		List playerList = new ArrayList(getMain().getGameData().getPlayerList());
		Collections.sort(playerList, new WOPPlayer.VPComparator());
		for (int i = 0; i < 9; i++) {
			CGFUIImage partTitle = (CGFUIImage) this.getDialog().getPartsMap()
					.get("prize.title" + String.valueOf(i + 1));
			CGFUIImage partPlayer = (CGFUIImage) this.getDialog().getPartsMap()
					.get("prize.player" + String.valueOf(i + 1));
			CGFUIImage partPoint = (CGFUIImage) this.getDialog().getPartsMap()
					.get("prize.point" + String.valueOf(i + 1));
			if (i < getMain().getGameData().getNinzu()) {
				WOPPlayer player = (WOPPlayer) playerList.get(i);
				if (i == 0) {
					partTitle.setLabel("勝利者");
				} else if (player.getVp() == 0) {
					partTitle.setLabel("滅亡");
				} else {
					partTitle.setLabel(String.valueOf(i + 1) + "位");
				}
				partPlayer.setBgColor(player.getColor());
				partPlayer.setLabel(player.getName());
				partPoint.setBgColor(player.getColor());
				partPoint.setLabel(String.format("%8d点", player.getVp()));
				partTitle.setEnable(true);
				partPlayer.setEnable(true);
				partPoint.setEnable(true);
			} else {
				partTitle.setEnable(false);
				partPlayer.setEnable(false);
				partPoint.setEnable(false);
			}
		}
	}

	public class CloseHandler implements CGFUIHandler {
		public static final String HANDLER_NAME = "prize.close";

		public String getName() {
			return HANDLER_NAME;
		}

		public void onClick() {
			JOptionPane.showMessageDialog(null, "ゲームを終了します");
			System.exit(0);
		}

		public void onRightClick() {
		}

		public void onMove() {
		}
	}
}
