package sjima.wop.action;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import sjima.cgf.CGFDialogAction;
import sjima.cgf.CGFUIHandler;
import sjima.cgf.CGFUIImage;
import sjima.cgf.CGFUtil;
import sjima.wop.WOPMain;
import sjima.wop.WOPMapInfo;
import sjima.wop.mode.WOPDialogMode;

public class WOPScenarioDialogAction extends CGFDialogAction {
	public static final String DIALOG_NAME = "scenario";
	private String returnDialog;
	private String returnDialog2;
	private WOPMapInfo mapInfo;

	public WOPScenarioDialogAction(WOPMain main) {
		setMain(main);
	}

	@Override
	public void commit() {
	}

	@Override
	public Map createHandlerMap() {
		Map map = new HashMap();
		CGFUIHandler handler = new CloseHandler();
		map.put(handler.getName(), handler);

		return map;
	}

	@Override
	public String getDialogName() {
		return DIALOG_NAME;
	}

	@Override
	public void setup() {
		updateDialog();
	}

	private void updateDialog() {
		List lineList = new ArrayList();
		for (Iterator ite = getMapInfo().getCommentList().iterator(); ite
				.hasNext();) {
			String comment = (String) ite.next();
			lineList.addAll(CGFUtil.divideStringByWidth(comment, 72));
		}
		lineList.add("");
		lineList.add("ゲームの長さ：" + getMapInfo().getEndTurn() + "ターン");
		StringBuffer buf = new StringBuffer(100);
		for (Iterator ite = getMapInfo().getPlayerList().iterator(); ite
				.hasNext();) {
			String player = (String) ite.next();
			if (buf.length() == 0) {
				buf.append("登場勢力数：" + mapInfo.getMaxPlayer() + "（");
			} else {
				buf.append("、");
			}
			buf.append(player);
		}
		buf.append("）");
		lineList.addAll(CGFUtil.divideStringByWidth(buf.toString(), 72));

		CGFUIImage part = (CGFUIImage) getDialog().getPartsMap().get(
				"scenario.name");
		part.setLabel(mapInfo.getTitle());
		for (int i = 0; i < 13; i++) {
			part = (CGFUIImage) getDialog().getPartsMap().get(
					"scenario.line" + i);
			if (i >= lineList.size()) {
				part.setLabel("");
			} else {
				part.setLabel((String) lineList.get(i));
			}
		}
		setCloseEnable(true);
	}

	public void setReturnDialog(String returnDialog) {
		this.returnDialog = returnDialog;
	}

	public String getReturnDialog() {
		return returnDialog;
	}

	public void setMapInfo(WOPMapInfo mapInfo) {
		this.mapInfo = mapInfo;
	}

	public WOPMapInfo getMapInfo() {
		return mapInfo;
	}
	
	public void closeDialog() {
		super.closeDialog();
		if (getReturnDialog() != null) {
			WOPDialogMode dialogMode = (WOPDialogMode) ((WOPMain) getMain())
					.getGameData().getModeList().get(
							WOPDialogMode.MODE_NAME);
			getMain().getGameData().setCurrentMode(dialogMode);
			dialogMode.setFinishHandler(null);
			CGFDialogAction action = dialogMode
					.getAction(getReturnDialog());
			if (action instanceof WOPMenu1Action) {
				WOPMenu1Action menuAction = (WOPMenu1Action) action;
				menuAction.setReturnDialog(getReturnDialog2());
			}
			dialogMode.dispDialog(action);
		}
	}

	public class CloseHandler implements CGFUIHandler {
		public static final String HANDLER_NAME = "scenario.close";

		public String getName() {
			return HANDLER_NAME;
		}

		public void onClick() {
			closeDialog();
		}

		public void onRightClick() {
		}

		public void onMove() {
		}
	}

	public void setReturnDialog2(String returnDialog2) {
		this.returnDialog2 = returnDialog2;
	}

	public String getReturnDialog2() {
		return returnDialog2;
	}
}
