package sjima.wop.action;

import java.awt.Color;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import sjima.cgf.CGFDialogAction;
import sjima.cgf.CGFUIHandler;
import sjima.cgf.CGFUIImage;
import sjima.cgf.CGFUtil;
import sjima.wop.WOPMain;
import sjima.wop.WOPPlayer;
import sjima.wop.WOPTerrain;
import sjima.wop.mode.WOPDialogMode;

public class WOPTerrainListDialogAction extends CGFDialogAction {
	public static final String DIALOG_NAME = "terrain";
	private String returnDialog;
	private String returnDialog2;
	public static final int MAX_LINE = 11;
	private int page = 0;
	private int targetIx = 0;
	private static final Color COLOR_STANDARD_TARGET = CGFUtil
			.stringToColor("159-159-159-191");
	private static final Color COLOR_NORMAL = CGFUtil
			.stringToColor("0-0-0-255");
	private static final Color COLOR_HIGH = CGFUtil
			.stringToColor("191-0-0-255");
	private static final Color COLOR_LOW = CGFUtil.stringToColor("0-0-255-255");

	public WOPTerrainListDialogAction(WOPMain main) {
		setMain(main);
	}

	@Override
	public void commit() {
	}

	@Override
	public Map createHandlerMap() {
		Map map = new HashMap();
		CGFUIHandler handler = new CloseHandler();
		map.put(handler.getName(), handler);
		handler = new PrevHandler();
		map.put(handler.getName(), handler);
		handler = new NextHandler();
		map.put(handler.getName(), handler);
		handler = new TargetHandler();
		map.put(handler.getName(), handler);

		return map;
	}

	@Override
	public String getDialogName() {
		return DIALOG_NAME;
	}

	@Override
	public void setup() {
		updateDialog();
	}

	private void updateDialog() {
		CGFUIImage part = (CGFUIImage) getDialog().getPartsMap().get(
				"terrain.target");
		WOPPlayer player = null;
		if (getTargetIx() == 0) {
			part.setBgColor(COLOR_STANDARD_TARGET);
			part.setLabel("標準");
		} else {
			player = (WOPPlayer) getMain().getGameData().getPlayer(
					String.valueOf(getTargetIx()));
			part.setBgColor(player.getColor());
			part.setLabel(player.getName());
		}

		List terrainList = new ArrayList(getMain().getGameData()
				.getTerrainMap().values());
		if (getPage() < totalPage() - 1) {
			part = (CGFUIImage) getDialog().getPartsMap().get("terrain.next");
			part.setEnable(true);
		} else {
			part = (CGFUIImage) getDialog().getPartsMap().get("terrain.next");
			part.setEnable(false);
		}
		if (getPage() > 0) {
			part = (CGFUIImage) getDialog().getPartsMap().get("terrain.prev");
			part.setEnable(true);
		} else {
			part = (CGFUIImage) getDialog().getPartsMap().get("terrain.prev");
			part.setEnable(false);
		}
		for (int i = 0; i < MAX_LINE; i++) {
			int ix = i + page * MAX_LINE;
			if (ix < terrainList.size()) {
				WOPTerrain terrain = (WOPTerrain) terrainList.get(ix);

				part = (CGFUIImage) getDialog().getPartsMap().get(
						"terrain.image" + (i + 1));
				part.setEnable(true);
				part.setImage(terrain.getImage());
				part.setImagePath(terrain.getImagePath());

				part = (CGFUIImage) getDialog().getPartsMap().get(
						"terrain.name" + (i + 1));
				part.setEnable(true);
				part.setLabel(terrain.getName());

				if (player != null) {
					updateParaLabel("terrain.fertility", i, terrain
							.getFertility(player), terrain.getFertility());
					updateParaLabel("terrain.attack", i, terrain
							.getAttack(player), terrain.getAttack());
					updateParaLabel("terrain.defence", i, terrain
							.getDefence(player), terrain.getDefence());
					updateParaLabel("terrain.capacity", i, terrain
							.getCapacity(player), terrain.getCapacity());
					updateParaLabel("terrain.garrison", i, terrain
							.getGarrison(player), terrain.getGarrison());
					updateParaLabel("terrain.maxgrowth", i, terrain
							.getMaxGrowth(player), terrain.getMaxGrowth());
					updateParaLabel("terrain.movestart", i, terrain
							.getMoveStart(player), terrain.getMoveStart());
					updateParaLabel("terrain.attackMorale", i, terrain
							.getAttackMorale(player), terrain.getAttackMorale());
					updateParaLabel("terrain.defenceMorale", i, terrain
							.getDefenceMorale(player), terrain
							.getDefenceMorale());
				} else {
					updateParaLabel("terrain.fertility", i, terrain
							.getFertility(), terrain.getFertility());
					updateParaLabel("terrain.attack", i, terrain.getAttack(),
							terrain.getAttack());
					updateParaLabel("terrain.defence", i, terrain.getDefence(),
							terrain.getDefence());
					updateParaLabel("terrain.capacity", i, terrain
							.getCapacity(), terrain.getCapacity());
					updateParaLabel("terrain.garrison", i, terrain
							.getGarrison(), terrain.getGarrison());
					updateParaLabel("terrain.maxgrowth", i, terrain
							.getMaxGrowth(), terrain.getMaxGrowth());
					updateParaLabel("terrain.movestart", i, terrain
							.getMoveStart(), terrain.getMoveStart());
					updateParaLabel("terrain.attackMorale", i, terrain
							.getAttackMorale(), terrain.getAttackMorale());
					updateParaLabel("terrain.defenceMorale", i, terrain
							.getDefenceMorale(), terrain.getDefenceMorale());
				}
			} else {
				part = (CGFUIImage) getDialog().getPartsMap().get(
						"terrain.image" + (i + 1));
				part.setEnable(false);
				part = (CGFUIImage) getDialog().getPartsMap().get(
						"terrain.name" + (i + 1));
				part.setEnable(false);
				part = (CGFUIImage) getDialog().getPartsMap().get(
						"terrain.fertility" + (i + 1));
				part.setEnable(false);
				part = (CGFUIImage) getDialog().getPartsMap().get(
						"terrain.attack" + (i + 1));
				part.setEnable(false);
				part = (CGFUIImage) getDialog().getPartsMap().get(
						"terrain.defence" + (i + 1));
				part.setEnable(false);
				part = (CGFUIImage) getDialog().getPartsMap().get(
						"terrain.capacity" + (i + 1));
				part.setEnable(false);
				part = (CGFUIImage) getDialog().getPartsMap().get(
						"terrain.garrison" + (i + 1));
				part.setEnable(false);
				part = (CGFUIImage) getDialog().getPartsMap().get(
						"terrain.maxgrowth" + (i + 1));
				part.setEnable(false);
				part = (CGFUIImage) getDialog().getPartsMap().get(
						"terrain.movestart" + (i + 1));
				part.setEnable(false);
				part = (CGFUIImage) getDialog().getPartsMap().get(
						"terrain.attackMorale" + (i + 1));
				part.setEnable(false);
				part = (CGFUIImage) getDialog().getPartsMap().get(
						"terrain.defenceMorale" + (i + 1));
				part.setEnable(false);
			}
		}

		setCloseEnable(true);
	}

	public void updateParaLabel(String handlerName, int i, int value,
			int stdValue) {
		CGFUIImage part = (CGFUIImage) getDialog().getPartsMap().get(
				handlerName + (i + 1));
		part.setEnable(true);
		part.setLabel(String.valueOf(value));
		if (stdValue < value) {
			part.setFgColor(COLOR_HIGH);
		} else if (value < stdValue) {
			part.setFgColor(COLOR_LOW);
		} else {
			part.setFgColor(COLOR_NORMAL);
		}
	}

	public void setReturnDialog(String returnDialog) {
		this.returnDialog = returnDialog;
	}

	public String getReturnDialog() {
		return returnDialog;
	}

	public void setReturnDialog2(String returnDialog2) {
		this.returnDialog2 = returnDialog2;
	}

	public String getReturnDialog2() {
		return returnDialog2;
	}

	public void setPage(int page) {
		this.page = page;
	}

	public int getPage() {
		return page;
	}

	public int totalPage() {
		int result = getMain().getGameData().getTerrainMap().size() / MAX_LINE;
		if ((getMain().getGameData().getTerrainMap().size() % MAX_LINE) > 0) {
			result++;
		}
		return result;
	}

	public void closeDialog() {
		super.closeDialog();
		if (getReturnDialog() != null) {
			WOPDialogMode dialogMode = (WOPDialogMode) ((WOPMain) getMain())
					.getGameData().getModeList().get(WOPDialogMode.MODE_NAME);
			getMain().getGameData().setCurrentMode(dialogMode);
			dialogMode.setFinishHandler(null);
			CGFDialogAction action = dialogMode.getAction(getReturnDialog());
			if (action instanceof WOPMenu1Action) {
				WOPMenu1Action menuAction = (WOPMenu1Action) action;
				menuAction.setReturnDialog(getReturnDialog2());
			}
			dialogMode.dispDialog(action);
		}
	}

	public void setTargetIx(int targetIx) {
		this.targetIx = targetIx;
	}

	public int getTargetIx() {
		return targetIx;
	}

	public class CloseHandler implements CGFUIHandler {
		public static final String HANDLER_NAME = "terrain.close";

		public String getName() {
			return HANDLER_NAME;
		}

		public void onClick() {
			closeDialog();
		}

		public void onRightClick() {
		}

		public void onMove() {
		}
	}

	public class PrevHandler implements CGFUIHandler {
		public static final String HANDLER_NAME = "terrain.prev";

		public String getName() {
			return HANDLER_NAME;
		}

		public void onClick() {
			setPage(getPage() - 1);

			updateDialog();
			WOPDialogMode mode = (WOPDialogMode) getMain().getGameData()
					.getCurrentMode();
			mode.repaintDialog();
		}

		public void onRightClick() {
		}

		public void onMove() {
		}
	}

	public class NextHandler implements CGFUIHandler {
		public static final String HANDLER_NAME = "terrain.next";

		public String getName() {
			return HANDLER_NAME;
		}

		public void onClick() {
			setPage(getPage() + 1);

			updateDialog();
			WOPDialogMode mode = (WOPDialogMode) getMain().getGameData()
					.getCurrentMode();
			mode.repaintDialog();
		}

		public void onRightClick() {
		}

		public void onMove() {
		}
	}

	public class TargetHandler implements CGFUIHandler {
		public static final String HANDLER_NAME = "terrain.target";

		public String getName() {
			return HANDLER_NAME;
		}

		public void onClick() {
			if (getMain().getGameData().getNinzu() == getTargetIx()) {
				setTargetIx(0);
			} else {
				setTargetIx(getTargetIx() + 1);
			}

			updateDialog();
			WOPDialogMode mode = (WOPDialogMode) getMain().getGameData()
					.getCurrentMode();
			mode.repaintDialog();
		}

		public void onRightClick() {
		}

		public void onMove() {
		}
	}
}
