/**
 * Wars of Powers 
 * 
 * copyright 2009 Mitsunobu SHIOJIMA
 */
package sjima.wop.event;

import java.awt.Color;
import java.util.List;

import org.w3c.dom.Node;

import sjima.cgf.CGFUtil;
import sjima.cgf.CGFXMLUtil;
import sjima.wop.WOPMain;

public abstract class WOPEvent {
	private WOPMain main;
	private String eno;
	private String name;
	private int rate;
	private int times;
	private List area;
	private Color color;
	private String desc;

	public WOPEvent(WOPMain main, String eno, String name, int rate, int times,
			Color color, String desc) {
		setMain(main);
		setEno(eno);
		setName(name);
		setRate(rate);
		setTimes(times);
		setArea(null);
		setColor(color);
		setDesc(desc);
	}

	public WOPEvent(WOPMain main, Node node) {
		setMain(main);
		setEno(CGFXMLUtil.getAttributeByName(node, "eno"));
		setName(CGFXMLUtil.getAttributeByName(node, "name"));
		setRate(CGFXMLUtil.getAttributeIntegerByName(node, "rate"));
		setTimes(CGFXMLUtil.getAttributeIntegerByName(node, "times"));
		setColor(CGFUtil.stringToColor(CGFXMLUtil.getAttributeByName(node,
				"color")));
		String desc = CGFXMLUtil.readByXPath(node, "desc");
		setDesc(desc);
		
		setArea(null);
	}

	public abstract String getEType();

	public abstract void execute();

	public void setEno(String eno) {
		this.eno = eno;
	}

	public String getEno() {
		return eno;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

	public void setRate(int rate) {
		this.rate = rate;
	}

	public int getRate() {
		return rate;
	}

	public void setTimes(int times) {
		this.times = times;
	}

	public int getTimes() {
		return times;
	}

	public void setArea(List area) {
		this.area = area;
	}

	public List getArea() {
		return area;
	}

	public void setMain(WOPMain main) {
		this.main = main;
	}

	public WOPMain getMain() {
		return main;
	}

	public void setColor(Color color) {
		this.color = color;
	}

	public Color getColor() {
		return color;
	}

	public String getRateString() {
		return String.format("%3.1f%sx%d", ((double) getRate()) / 10, "%",
				getTimes());
	}

	public void setDesc(String desc) {
		this.desc = desc;
	}

	public String getDesc() {
		return desc;
	}
}
