package sjima.wop.layer;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.image.BufferedImage;

import sjima.cgf.CGFCell;
import sjima.cgf.CGFLocation;
import sjima.cgf.CGFMain;
import sjima.cgf.CGFSize;
import sjima.cgf.CGFTerrain;
import sjima.cgf.layer.CGFTerrainLayer;

public class WOPTerrainLayer extends CGFTerrainLayer {
	public WOPTerrainLayer(CGFMain main, CGFSize size) {
		super(main, size);
	}
	
	public Rectangle eventAtLocation(CGFLocation loc, Color color) {
		Graphics2D gc = getLayerImage().createGraphics();
		Point p = getMain().getGameData().getLocationPoint(loc);
		CGFSize sqSize = getMain().getGameData().getSquareSize();
		Rectangle rect = new Rectangle(p.x, p.y, sqSize.width, sqSize.height);
		gc.setColor(color);
		gc.fillRect(rect.x, rect.y, rect.width, rect.height);
		return rect;
	}

	public void updateAtLocation(CGFLocation loc) {
		repaintAtLocation(loc);
	}

	public Rectangle repaintAtLocation(CGFLocation loc) {
		CGFCell cell = (CGFCell) getMain().getGameData().getCellTable()
				.getData(loc);
		Point p = getMain().getGameData().getLocationPoint(loc);
		CGFSize sqSize = getMain().getGameData().getSquareSize();
		Rectangle rect = new Rectangle(p.x, p.y, sqSize.width, sqSize.height);
		CGFTerrain terrain = cell.getTerrain();
		if (terrain == null) {
			System.out.println("unkown terrain [" + cell.getLocation() + "]");
			return rect;
		}
		BufferedImage img = terrain.getImage();
		Graphics2D gc = getLayerImage().createGraphics();
		gc.drawImage(img, p.x, p.y, null);
		return rect;
	}
}
