package sjima.wop.mode;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

import sjima.cgf.CGFLocation;
import sjima.cgf.CGFMain;
import sjima.cgf.CGFMode;
import sjima.cgf.layer.CGFBorderTerrainLayer;
import sjima.cgf.layer.CGFCursolLayer;
import sjima.cgf.layer.CGFInfoBoardLayer;
import sjima.wop.layer.WOPForceLayer;
import sjima.wop.layer.WOPTerrainLayer;
import sjima.wop.phase.WOPTargetChoicePhase;

public class WOPDisplayMode extends CGFMode {
	private final static Class[] ENABLE_LAYERS = { WOPForceLayer.class,
			WOPTerrainLayer.class, CGFBorderTerrainLayer.class,
			CGFCursolLayer.class, CGFInfoBoardLayer.class };
	private Set enableLayerSet = new HashSet(Arrays.asList(ENABLE_LAYERS));

	private Runnable finishHandler = null;

	public WOPDisplayMode(CGFMain main) {
		super(main);
	}

	public void setFinishHandler(Runnable handler) {
		this.finishHandler = handler;
	}

	public Runnable getFinishHandler() {
		return this.finishHandler;
	}

	public Set getEnableLayerSet() {
		return enableLayerSet;
	}

	public void setEnableLayerSet(Set enableLayerSet) {
		this.enableLayerSet = enableLayerSet;
	}

	protected synchronized void moveMouse(CGFLocation newLoc) {
		super.moveMouse(newLoc);
	}

	protected void click(CGFLocation loc) {
		if (getMain().getGameData().getPhaseManager().getCurrentPhase()
				.getPhaseName().equals(WOPTargetChoicePhase.PHASE_NAME)) {
			WOPTargetChoicePhase phase = (WOPTargetChoicePhase) getMain()
					.getGameData().getPhaseManager().getCurrentPhase();
			phase.click(loc);
		}
	}

	protected void rightClick(CGFLocation loc) {
	}
}
