package sjima.wop.mode;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

import sjima.cgf.CGFLocation;
import sjima.cgf.CGFMain;
import sjima.cgf.CGFMode;
import sjima.cgf.layer.CGFBorderTerrainLayer;
import sjima.wop.layer.WOPForceLayer;
import sjima.wop.layer.WOPTerrainLayer;

public class WOPImageSaveMode extends CGFMode {
	private final static Class[] ENABLE_LAYERS = { WOPForceLayer.class,
			WOPTerrainLayer.class, CGFBorderTerrainLayer.class };
	private Set enableLayerSet = new HashSet(Arrays.asList(ENABLE_LAYERS));

	private Runnable finishHandler = null;

	public WOPImageSaveMode(CGFMain main) {
		super(main);
	}

	public void setFinishHandler(Runnable handler) {
		this.finishHandler = handler;
	}

	public Runnable getFinishHandler() {
		return this.finishHandler;
	}

	public Set getEnableLayerSet() {
		return enableLayerSet;
	}

	public void setEnableLayerSet(Set enableLayerSet) {
		this.enableLayerSet = enableLayerSet;
	}

	protected synchronized void moveMouse(CGFLocation newLoc) {
		super.moveMouse(newLoc);
	}

	protected void click(CGFLocation loc) {
	}

	protected void rightClick(CGFLocation loc) {
	}
}
