package sjima.wop.phase;

import java.util.Iterator;
import java.util.List;

import sjima.cgf.CGFGamePhase;
import sjima.cgf.CGFMode;
import sjima.cgf.CGFUtil;
import sjima.wop.WOPMain;
import sjima.wop.event.WOPEvent;
import sjima.wop.event.WOPEventManager;
import sjima.wop.mode.WOPDisplayMode;

public class WOPEventPhase extends CGFGamePhase {
	public static final String PHASE_NAME = "イベント発生フェイズ";

	private WOPMain main;
	private WOPPhaseManager phaseManager;

	public WOPEventPhase(WOPMain main, WOPPhaseManager phaseManager) {
		super();
		setMain(main);
		setPhaseManager(phaseManager);
	}

	public void run() {
		getMain().getGameData().calTotalFertility();
		getMain().getGameData().getForceManager().calTotalStrength();
		List list = getEventManager().createHappendList();
		list = CGFUtil.shuffleList(list, list.size());
		for (Iterator ite = list.iterator(); ite.hasNext(); ) {
			WOPEvent event = (WOPEvent)ite.next();
			event.execute();
		}
		finish();
	}
	
	public WOPEventManager getEventManager() {
		return getMain().getGameData().getEventManager();
	}

	public CGFMode getDefaultMode() {
		return (CGFMode) getMain().getGameData().getModeList().get(
				WOPDisplayMode.MODE_NAME);
	}

	public String getPhaseName() {
		return PHASE_NAME;
	}


	public void setMain(WOPMain main) {
		this.main = main;
	}

	public WOPMain getMain() {
		return main;
	}

	public void setPhaseManager(WOPPhaseManager phaseManager) {
		this.phaseManager = phaseManager;
	}

	public WOPPhaseManager getPhaseManager() {
		return phaseManager;
	}

	public class FinishHandler implements Runnable {

		public void run() {
			finish();
		}

	}

}
