package sjima.wop.phase;

import java.util.ArrayList;
import java.util.List;

import sjima.cgf.CGFGamePhase;
import sjima.cgf.CGFPhaseManager;
import sjima.cgf.CGFTurnManager;
import sjima.wop.WOPMain;

public class WOPPhaseManager extends CGFPhaseManager {
	private WOPMain main;
	private CGFTurnManager turnManager;

	public WOPPhaseManager(WOPMain main) {
		setMain(main);
		buildPhaseList();
	}

	public void buildPhaseList() {
		List list = new ArrayList();
		list.add(new WOPTurnStartPhase(getMain(), this));
		list.add(new WOPEventPhase(getMain(), this));
		list.add(new WOPForceIncrementPhase(getMain(), this));
		list.add(new WOPTargetChoicePhase(getMain(), this));
		list.add(new WOPTargetDispPhase(getMain(), this));
		list.add(new WOPMovementPhase(getMain(), this));
		list.add(new WOPCombatPhase(getMain(), this));
		list.add(new WOPMovementPhase(getMain(), this));
		list.add(new WOPCombatPhase(getMain(), this));
		list.add(new WOPMovementPhase(getMain(), this));
		list.add(new WOPCombatPhase(getMain(), this));
		list.add(new WOPTurnEndPhase(getMain(), this));

		setPhaseList(list);
	}

	public void setMain(WOPMain main) {
		this.main = main;
	}

	public WOPMain getMain() {
		return main;
	}

	public CGFTurnManager getTurnManager() {
		return this.turnManager;
	}

	public void setTurnManager(CGFTurnManager turnManager) {
		this.turnManager = turnManager;
	}

	public CGFGamePhase nextPhase() {
		if (!getCurrentPhase().getPhaseName().equals(
				WOPTargetChoicePhase.PHASE_NAME)) {
			return super.nextPhase();
		}
		if (getTurnManager().getPlayerNo() < getMain().getGameData().getNinzu() - 1) {
			getTurnManager().setPlayerNo(getTurnManager().getPlayerNo() + 1);
			return getCurrentPhase();
		}
		return super.nextPhase();
	}
}
