package sjima.wop.phase;

import sjima.cgf.CGFGamePhase;
import sjima.cgf.CGFMode;
import sjima.wop.WOPMain;
import sjima.wop.action.WOPTargetListDialogAction;
import sjima.wop.mode.WOPDialogMode;
import sjima.wop.mode.WOPDisplayMode;

public class WOPTargetDispPhase extends CGFGamePhase {
	public static final String PHASE_NAME = "目標表示フェイズ";
	private WOPMain main;

	public WOPTargetDispPhase(WOPMain main, WOPPhaseManager phaseManager) {
		super();
		setPhaseManager(phaseManager);
		setMain(main);
	}

	public CGFMode getDefaultMode() {
		return (CGFMode) getMain().getGameData().getModeList().get(
				WOPDisplayMode.MODE_NAME);
	}

	public String getPhaseName() {
		return PHASE_NAME;
	}

	public void run() {
		getMain().getGameData().changeCurrentMode(WOPDialogMode.MODE_NAME);
		WOPDialogMode dialogMode = (WOPDialogMode) getMain().getGameData()
				.getCurrentMode();
		WOPTargetListDialogAction action = (WOPTargetListDialogAction) dialogMode
				.getAction(WOPTargetListDialogAction.DIALOG_NAME);
		action.setPhasePlayerNo(null);
		action.setTimeout(getMain().getGameData().getMessageWaitTime());
		
		dialogMode.dispDialog(action);
	}

	public void setMain(WOPMain main) {
		this.main = main;
	}

	public WOPMain getMain() {
		return main;
	}

}
